﻿namespace Sensory
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            pokażInformacjeOUrządzeniu();
            DeviceDisplay.Current.MainDisplayInfoChanged += Current_MainDisplayInfoChanged;

#if WINDOWS
            Default_BatteryInfoChanged(this, new BatteryInfoChangedEventArgs(Battery.Default.ChargeLevel, Battery.Default.State, Battery.Default.PowerSource));
#endif
            Battery.Default.BatteryInfoChanged += Default_BatteryInfoChanged;
        }

        private void pokażInformacjeOUrządzeniu()
        {
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            sb.Append("Informacje o urządzeniu\n");
            sb.AppendLine($"Model: {DeviceInfo.Current.Model}");
            sb.AppendLine($"Producent: {DeviceInfo.Current.Manufacturer}");
            sb.AppendLine($"Nazwa: {DeviceInfo.Current.Name}");
            sb.AppendLine($"Wersja systemu: {DeviceInfo.Current.VersionString}");
            sb.AppendLine($"Idiom: {DeviceInfo.Current.Idiom}");
            sb.AppendLine($"Platforma: {DeviceInfo.Current.Platform}");
            string typUrządzenia = (DeviceInfo.Current.DeviceType == DeviceType.Virtual) ? "wirtualne" : "rzeczywiste";
            sb.AppendLine($"Typ urządzenia: {typUrządzenia}");
            lbUrządzenie.Text = sb.ToString();
        }

        private void pokażInformacjeOWyświetlaczu()
        {
            string s = "Informacje o ekranie";
            s += $"\nRozdzielczość: {DeviceDisplay.Current.MainDisplayInfo.Width} x {DeviceDisplay.Current.MainDisplayInfo.Height}";
            s += $"\nObrót ekranu: {DeviceDisplay.Current.MainDisplayInfo.Rotation}";
            lbEkran.Text = s;
        }

        private void Current_MainDisplayInfoChanged(object? sender, DisplayInfoChangedEventArgs e)
        {
            pokażInformacjeOWyświetlaczu();
        }

        private void ContentPage_Loaded(object sender, EventArgs e)
        {
            pokażInformacjeOWyświetlaczu();
        }

        #region Bateria
        private void btnBateria_Clicked(object sender, EventArgs e)
        {
            //tu trzeba wymusić wystąpienie zdarzenia pod Windows??
            
        }

        private void Default_BatteryInfoChanged(object? sender, BatteryInfoChangedEventArgs e)
        {
            string s = "Stan baterii";
            s += $"\nŹródło: {e.PowerSource.ToString()}";
            s += $"\nStan: {e.State.ToString()}";
            s += $"\nPoziom naładowania: {e.ChargeLevel.ToString()}";
            lbBateria.Text = s;
        }
        #endregion
    }
}
